import { DataSource, DataSourceConfig } from 'apollo-datasource';
import { KeyValueCache } from 'apollo-server-caching';
import { Connection, EntityManager, EntityTarget, FindManyOptions, FindOneOptions, RemoveOptions, Repository, SaveOptions } from 'typeorm';
import { GraphqlOrmDataSourceConfig } from './types';
export declare class GraphqlOrmDataSource<TContext = any> extends DataSource<TContext> {
    context?: TContext;
    cache?: KeyValueCache;
    orm: Connection;
    useCache: boolean;
    cacheTtl: number;
    constructor(ormConfig: GraphqlOrmDataSourceConfig);
    initialize(config: DataSourceConfig<TContext>): void;
    em(): EntityManager;
    repo<TEntity>(target: EntityTarget<TEntity>): Repository<TEntity>;
    protected getEntityCacheKey(repoName: string, id: any, options?: any): string;
    protected cacheGet<T>(key: string): Promise<T | undefined>;
    protected cacheSet(key: string, val: any): void;
    findOne<TEntity>(target: EntityTarget<TEntity>, id: any, options?: FindOneOptions<TEntity>): Promise<TEntity | undefined>;
    findManyByIds<TEntity>(target: EntityTarget<TEntity>, ids: any[], options?: FindManyOptions<TEntity>): Promise<Array<TEntity | undefined>>;
    saveOne<TEntity>(entity: TEntity, options?: SaveOptions): Promise<TEntity>;
    removeOne<TEntity>(entity: TEntity, options?: RemoveOptions): Promise<TEntity>;
}
